<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>UserDetail</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <!-- font -->
    <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Lato">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
</head>

<body onload="onPageLoading()">
    <div class="container mt-5">
        <h2>Thông tin người dùng</h2>
        <div class="jumbotron">
            <div class="form-group">
                <label for="inp-firstname">First Name</label>
                <input type="text" class="form-control" id="inp-firstname">
            </div>
            <div class="form-group">
                <label for="inp-lastname">Last Name</label>
                <input type="text" class="form-control" id="inp-lastname">
            </div>
            <div class="form-group">
                <label for="inp-country">Country</label>
                <input type="text" class="form-control" id="inp-country">
            </div>
            <div class="form-group">
                <label for="txt-subject">Subject</label>
                <textarea class="form-control" id="txt-subject" rows="3"></textarea>
            </div>
            <div class="form-group d-flex justify-content-between align-items-center">
                <button class="btn btn-success btn-lg" onclick="onBtnSuaClick()">Sửa</button>
                <a href="index.html">Quay lại</a>
            </div>
        </div>
    </div>
</body>
<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-register-java-api/users"
    var gUser = { id: 0, firstname: "", lastname: "", country: "", subject: "", customerType: "", registerStatus: "" };
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
        //B1: thu thap du lieu
        thuThapDuLieu(gUser);
        //B2: kiem tra du lieu
        var vDuLieuHopLe = kiemTraDuLieu(gUser);
        if (vDuLieuHopLe) {
            //B3: goi Api
            var vXmlHttp = new XMLHttpRequest();
            callApiGetUser(gUser, vXmlHttp);
            //B4: hien thi User len trang web
            showUser(vXmlHttp);
        }
    }

    function onBtnSuaClick() {
        //B1: thu thap du lieu
        thuThapDuLieuSua(gUser);
        //B2: kiem tra du lieu
        var vDuLieuHopLe = kiemTraDuLieuSua(gUser);
        if (vDuLieuHopLe) {
            //B3: goi Api
            var vXmlHttp = new XMLHttpRequest();
            callApiChangeUser(gUser, vXmlHttp);
            //B4: Thuc hien sua thanh cong va thong bao
            changeUserAndAlert(vXmlHttp);
        }
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function thuThapDuLieu(paramUserObj) {
        // get data from query string
        var vUrlString = window.location.href; //đường đẫn gọi đến trang
        var vUrl = new URL(vUrlString);
        // get parameters
        paramUserObj.id = vUrl.searchParams.get("id");
        paramUserObj.firstname = vUrl.searchParams.get("firstname");
        paramUserObj.lastname = vUrl.searchParams.get("lastname");
        paramUserObj.country = vUrl.searchParams.get("country");
        paramUserObj.subject = vUrl.searchParams.get("subject");
        paramUserObj.customerType = vUrl.searchParams.get("customerType");
        paramUserObj.registerStatus = vUrl.searchParams.get("registerStatus");
    }

    function kiemTraDuLieu(paramUserObj) {
        if (paramUserObj.id == null) {
            alert("Không lấy được id user!");
            backToUserListView();
            return false;
        }
        return true;
    }

    function callApiGetUser(paramUserObj, paramXmlHttp) {
        paramXmlHttp.open("GET", gBASE_URL + "/" + paramUserObj.id, true);
        paramXmlHttp.send();
    }

    function showUser(paramXmlHttp) {
        paramXmlHttp.onreadystatechange = function () {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK) {
                if (this.status == gREQUEST_STATUS_OK) {
                    console.log("response Text = " + paramXmlHttp.responseText);  // xem trên console.log để biết cấu trúc
                    // code xử lý response ở đây
                    /*thêm code xử lý response*/
                    var vUserResponse = JSON.parse(paramXmlHttp.responseText);

                    var vFirstnameInputElement = document.getElementById("inp-firstname");
                    var vLastnameInputElement = document.getElementById("inp-lastname");
                    var vCountryInputElement = document.getElementById("inp-country");
                    var vSubjectTextareaElement = document.getElementById("txt-subject");

                    vFirstnameInputElement.value = vUserResponse.firstname;
                    vLastnameInputElement.value = vUserResponse.lastname;
                    vCountryInputElement.value = vUserResponse.country;
                    vSubjectTextareaElement.value = vUserResponse.subject;
                }
                //Informational responses (100–199),
                //Successful responses (200–299),
                //Redirects (300–399),
                //Client errors (400–499),
                //and Server errors (500–599).
                else if (this.status >= 400 && this.status < 600) {
                    alert("Lấy thông tin user thất bại!");
                    backToUserListView();
                }
            }
        };
    }

    function thuThapDuLieuSua(paramUserObj) {
        var vFirstnameInputElement = document.getElementById("inp-firstname");
        var vLastnameInputElement = document.getElementById("inp-lastname");
        var vCountryInputElement = document.getElementById("inp-country");
        var vSubjectTextareaElement = document.getElementById("txt-subject");

        paramUserObj.firstname = vFirstnameInputElement.value.trim();
        paramUserObj.lastname = vLastnameInputElement.value.trim();
        paramUserObj.country = vCountryInputElement.value.trim();
        paramUserObj.subject = vSubjectTextareaElement.value.trim();
    }

    function kiemTraDuLieuSua(paramUserObj) {
        if (paramUserObj.firstname == "") {
            alert("Bạn chưa nhập firstname!");
            return false;
        }
        if (paramUserObj.lastname == "") {
            alert("Bạn chưa nhập lastname!");
            return false;
        }
        if (paramUserObj.country == "") {
            alert("Bạn chưa nhập country!");
            return false;
        }
        if (paramUserObj.subject == "") {
            alert("Bạn chưa nhập subject!");
            return false;
        }
        return true;
    }

    function callApiChangeUser(paramUserObj, paramXmlHttp) {
        paramXmlHttp.open("PUT", gBASE_URL + "/" + paramUserObj.id);
        paramXmlHttp.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
        paramXmlHttp.send(JSON.stringify(paramUserObj)); //send request - gửi request
    }

    function changeUserAndAlert(paramXmlHttp) {
        paramXmlHttp.onreadystatechange = function () {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK) {
                if (this.status == gREQUEST_STATUS_OK) {
                    alert("Cập nhật thông tin thành công: " + this.responseText);
                    backToUserListView();
                }
                //Informational responses (100–199),
                //Successful responses (200–299),
                //Redirects (300–399),
                //Client errors (400–499),
                //and Server errors (500–599).
                else if (this.status >= 400 && this.status < 600) {
                    alert("Cập nhật thông tin thất bại!");
                    backToUserListView();
                }
            }
        }
    }

    function backToUserListView() {
        window.location.href = "index.html";
    }
</script>

</html>